import 'package:dio/dio.dart';
import 'dart:convert';
import 'package:html/parser.dart';
import 'package:html/dom.dart';

import 'model.dart';

class Scraper {
  String JSessionID = '';

  Future<void> getJSessionID() async {
    String uri = "https://www.peoplestuffuk.com/WFMMCDPRD/Login.jsp";

    Dio dio = Dio();
    var response = await dio.post(uri,
        options: Options(
          headers: {
            'User-Agent':
                'Mozilla/5.0 (X11; Linux x86_64; rv:66.0) Gecko/20100101 Firefox/66.0',
            'Accept':
                'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
            'Accept-Language': 'en-US,en;q=0.5',
            'Referer':
                'https://www.peoplestuffuk.com/WFMMCDPRD/rws/ess/ess_notice_board.jsp?mm=ESS',
            'DNT': '1',
            'Connection': 'keep-alive',
            'Upgrade-Insecure-Requests': '1',
            'Cookie-Installing-Permission': 'required',
            'Pragma': 'no-cache',
            'Cache-Control': 'no-cache',
          },
        ));

    String headers = json.decode(response.headers['set-cookie']
        .toString()
        .replaceAll('HttpOnly', '')
        .replaceAll(']', '')
        .replaceAll('[', '')
        .split(";")
        .toString()
        .replaceAll('[', '{"')
        .replaceAll(']', '"}')
        .replaceAll(',', '","')
        .replaceAll('=', '":"')
        .replaceAll(' ', '')
        .replaceAll(',"",""', ''))['JSESSIONID'];

    JSessionID = headers;

    return;
  }

  Future<bool> loginStageOne(String employeeId, String password) async {
    await getJSessionID();
    String uri = "https://www.peoplestuffuk.com/WFMMCDPRD/LoginSubmit.jsp";
    //JSessionID = "1706bfc175471453bc5ad5f19de8.app1-prd-ojvm4";
    Dio dio = Dio();
    await dio.post(uri,
        options: Options(
          headers: {
            'User-Agent':
                'Mozilla/5.0 (X11; Linux x86_64; rv:66.0) Gecko/20100101 Firefox/66.0',
            'Accept':
                'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
            'Accept-Language':
                'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
            'Referer': 'https://www.peoplestuffuk.com/WFMMCDPRD/Login.jsp',
            'Content-Type': 'application/x-www-form-urlencoded',
            'DNT': '1',
            'Connection': 'keep-alive',
            'Cookie': '''JSESSIONID=${JSessionID}; ServerID=1105''',
            'Upgrade-Insecure-Requests': '1',
            'Cookie-Installing-Permission': 'required',
            'Pragma': 'no-cache',
            'Cache-Control': 'no-cache',
          },
        ),
        data: FormData.from({
          'localeCode': '',
          'uType': '',
          'switchUserID': '',
          'browserTimeZoneOffset': '-60',
          'txtUserID': employeeId,
          'txtPassword': password,
        }));

    return true;
  }

  Future<List<PersonWeek>> extractPersonData(Document htmlData) async {
    String responseData = (htmlData.outerHtml
        .split("var empVsWeekDetailsBO = ")[1]
        .split("var displayContract = true;")[0]
        .replaceAll(';', '')
        .replaceAll(' ', ''));
    Map jsonData = json.decode(responseData);

    List<PersonWeek> personData = [];
    jsonData.forEach((key, value) {
      personData.add(PersonWeek.fromMap(value));
    });

    return personData;
  }

  Future<List<Task>> extractTaskData(Document htmlData, DateTime date) async {
    String dateString =
        "${date.year}${date.month.toString().padLeft(2, '0')}${date.day.toString().padLeft(2, '0')}";

    Element taskDataElement = htmlData.getElementById("task_$dateString");
    String taskDataString = taskDataElement.attributes["value"];

    List activitySplitTasks = taskDataString.split("^^^");
    // Ends in '^^^' so there is an extra element at the end, removes it.
    activitySplitTasks.removeLast();

    List<Task> taskSplitTasks = activitySplitTasks
        .map((task) => Task.fromList(task.split("~~~")))
        .toList();

    return taskSplitTasks;
  }

  Future<Document> scrapeHtml() async {
    String uri = "https://www.peoplestuffuk.com/WFMMCDPRD/ModuleSelection.jsp";

    Dio dio = Dio();
    var response = await dio.get(
      uri,
      options: Options(
        headers: {
          'User-Agent':
              'Mozilla/5.0 (X11; Linux x86_64; rv:66.0) Gecko/20100101 Firefox/66.0',
          'Accept-Language': 'en-US,en;q=0.5',
          'Accept':
              'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
          'Referer': 'https://www.peoplestuffuk.com/WFMMCDPRD/Login.jsp',
          'Content-Type': 'application/x-www-form-urlencoded',
          'DNT': '1',
          'Connection': 'keep-alive',
          'Cookie': 'JSESSIONID=${JSessionID}; ServerID=1105',
          'Upgrade-Insecure-Requests': '1',
          'Cookie-Installing-Permission': 'required',
          'Pragma': 'no-cache',
          'Cache-Control': 'no-cache'
        },
      ),
    );

    var responseData = parse(response.data);

    return responseData;
  }

  PersonWeek extractSinglePersonData(
      List<PersonWeek> allPersonData, String employeeId) {
    var person;
    for (person in allPersonData) {
      if (person.employee.employeeId == employeeId) {
        return person;
      }
    }

    return PersonWeek();
  }

  Future<bool> login(employeeId, password) async {
    try {
      await loginStageOne(employeeId, password);
    } on DioError {
      print("[INFO] Login stage one complete.");
    }

    return true;
  }
}
